// dllmain.cpp : DLL AvP[ṼGg |Cg`܂B
#include "stdafx.h"

HMODULE hInterfaceDll = NULL;
HMODULE hDll = NULL;

using namespace std;

void InitializeDLLLoad();
HMODULE LoadDLL(LPCTSTR lpLibFileName);
FARPROC GetDLLProcAddress(HMODULE hModule, 
                          LPCSTR lpProcName);
DWORD GetDLLFileName( HMODULE hHandle, TCHAR *szFileName, DWORD len);
BOOL FreeDLL(HMODULE hHandle);
void KillDLLLoad();

extern void delete_drivers();

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		hDll = hModule;
		::CoInitializeEx( NULL, COINIT_APARTMENTTHREADED );
		InitializeDLLLoad();

		break;
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
		break;
	case DLL_PROCESS_DETACH:
		KillDLLLoad();
		if( hInterfaceDll ){
			::FreeLibrary( hInterfaceDll );
			hInterfaceDll = NULL;
		}
		delete_drivers();
		::CoUninitialize();
		break;
	}
	return TRUE;
}

